<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function getJobPositions() {
        $sql = "CALL `GetJobPositions`()";
        return DB::query(Database::SELECT, $sql)->execute()->as_array();
    }

    public static function ofFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`(:faculty)";
        return DB::query(Database::SELECT, $sql)
            ->param(':faculty', $facultyID)
            ->execute();
    }

    public static function ofDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`(:id)";
        return DB::query(Database::SELECT, $sql)
            ->param(':id', $departmentID)
            ->execute();
    }

    public static function searchTeachers($facultyID, $departmentID, $last, $first, $second) {
        $sql = "CALL `SearchTeachers`(:faculty, :department, :last, :first, :second)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':last'       => $last,
                ':first'      => $first,
                ':second'     => $second,
            ])->execute();
    }

    public static function searchTeacherNew($facultyID, $departmentID, $last, $first, $second, $disciplineID) {
        $sql = "CALL `SearchTeacherNew`(:faculty, :department, :last, :first, :second, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':discipline' => $disciplineID,
                ':last'       => $last,
                ':first'      => $first,
                ':second'     => $second,
            ])->execute();
    }
}